/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test9.c -o outputname -Wall 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary


// function prototypes  -with or without arg names
int myownprint( double ); 
int change( double *, int, double );
int change2( double *, double );


int main(  )
{
   // #9 function arguments 
   
   int i;
   double vec[10];
   
   vec[0] = 10.01;
   vec[1] = 0.111;
   vec[2] = 3.221;
   vec[3] = 4.231;
   vec[4] = -4.004;
   vec[5] = -5544;
   vec[6] = .6666;
   vec[7] = 7001;
   vec[8] = 8000;
   vec[9] = -9090;
   
   printf(" { ");
   for( i=0; i<10; i++ )
      printf("%g ", vec[i] );
   printf("}\n");
   
   // argument passed by value
   myownprint( vec[3] );  
   // myownprint cannot modify vec[3], but only use it
   
   
   
   // In order for a function to modify the value of its arguments, 
   // these have to be passed by reference, i.e. the function needs to 
   // know their physical address.

   // argument is passed by reference 
   // &vec[0] (or vec) is the address of the vector vec

   
   change( vec, 3, 33.3 );
   change( &vec[3], 3, 33.3 );
   //output?
   //{10.01, 0.111, 3.221, 4.231, -4.004, -5544, .6666, 7001, 8000, -9090};

   printf(" { ");
   for( i=0; i<10; i++ )
      printf("%g ", vec[i] );
   printf("}\n");
   

   //is the second argument of change necessary?
   
   //would this work?
   change( &vec[3], 0, 33.3 );

   
   change2( &vec[9], 4.4 );
   
   printf(" { ");
   for( i=0; i<10; i++ )
      printf("%g ", vec[i] );
   printf("}\n");
   

   
   /*
   // pay attention to the definitions of myownprint and change:
   // myownprint ( double )       <- value
   // change( double *,  ... )    <- pointer (i.e., address, reference)
   */

   return( 0 );
}



// function definitions

int  myownprint( double number )
{
   int i;

   for( i=1; i<=4; i++ )
      // useless; just to show that it is possible
      printf(" Function  myownprint  :  *** %.*g *** \n", i, number );

   return( 0 );
}


int change( double *v, int idx, double val )
{
   // &v[idx] == v + idx
   v[idx] = val;

   return( 0 );
}


int change2( double *v, double val )
{
   *v = val;
   //v[2] = val;
   
   return( 0 );
}



